
#include <stdio.h>
#include <stdlib.h>
#include "math.h"

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif

#define ENV	"CUTOFF"

static int	FirstAccess=1;
static double	CutOff=1.0;

#define delta2	(delta*delta)
#define M_PI_k	(M_PI*(double)k)

double	Box(delta,k)
double	delta;
int	k;
{
	char	*env;

	if (FirstAccess) {
	    FirstAccess=0;
	    if ((env=getenv(ENV))!=NULL) CutOff=atof(env);
	}
	if (k==0)
	    return CutOff*CutOff/(4.0*delta2);
	else
	    return (cos(M_PI_k*CutOff)+(M_PI_k*CutOff)*sin(M_PI_k*CutOff)-1.0)/
		   (2.0*M_PI_k*M_PI_k*delta2);
}
