
#include <stdio.h>

static size_t	fReadRev(ptr,size,items,file)
char		*ptr;
size_t		size,items;
FILE		*file;
{
	size_t	i,j,size1=size-1,size2=size/2,read=fread(ptr,size,items,file);
	char	*p1,*p2,c;

	for (i=0; i<read; i++) {
	    for (j=0; j<size2; j++) {
		p1=ptr+j; p2=ptr+size1-j; c=(*p1); *p1=(*p2); *p2=c;
	    }
	    ptr+=size;
	}
	return read;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	unsigned short	sData,sMin,sMax,tmp=0x1234;
	unsigned char	*ptr=(unsigned char *)&tmp;
	size_t		(*fRead)()=(*ptr==(tmp&0xff))?fread:fReadRev;
	FILE		*file;
	int		type,height,loc=1,cnt=0;
	float		fMin,fMax;
	short		width,I,I0,dark;
	unsigned long	lData,lMin,lMax;

	if (argc!=2) {
	    fputs("usage : ctd2dmm CTD\n",stderr); exit(1);
	}

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) {
		fprintf(stderr,"%s : file not open.\n",argv[1]); exit(1);
	    }

	do (void)fgetc(file); while (++loc<65);
	type=fgetc(file);
	++loc;

	do (void)fgetc(file); while (++loc<380);
	if (fgetc(file)==1) {
	    (void)(*fRead)(&fMin,sizeof(fMin),1,file); loc+=sizeof(fMin);
	    (void)(*fRead)(&fMax,sizeof(fMax),1,file); loc+=sizeof(fMax);

	    printf("enable\t%f\t%f\n",fMin,fMax);
	}
	++loc;

	do (void)fgetc(file); while (++loc<393);
	if (fgetc(file)==1) {
	    (void)fgetc(file); ++loc;
	    (void)(*fRead)(&fMin,sizeof(fMin),1,file); loc+=sizeof(fMin);
	    (void)(*fRead)(&fMax,sizeof(fMax),1,file); loc+=sizeof(fMax);

	    printf("absolute\t%f\t%f\n",fMin,fMax);
	}
	++loc;

	do (void)fgetc(file); while (++loc<527);
	(void)(*fRead)(&width,sizeof(width),1,file); loc+=sizeof(width);

	do (void)fgetc(file); while (++loc<557);
	(void)(*fRead)(&I,sizeof(I),1,file); loc+=sizeof(I);

	do (void)fgetc(file); while (++loc<569);
	(void)(*fRead)(&I0,sizeof(I0),1,file); loc+=sizeof(I0);
	(void)(*fRead)(&dark,sizeof(dark),1,file); loc+=sizeof(dark);

	height=(int)I+(int)I0+(int)dark;
	printf("%d\t%d\t%d\t%d\t%d\t%d\n",
	       (int)width,(int)I,(int)I0,(int)dark,height,(int)width*height);

	do (void)fgetc(file); while (++loc<=1024);
	switch(type) {
	    case 0 :
		while ((*fRead)(&sData,sizeof(sData),1,file)==1)
		    if (++cnt==1)
			sMin=sMax=sData;
		    else {
			if (sData<sMin) sMin=sData;
			if (sData>sMax) sMax=sData;
		    }

		printf("%d\t%hu\t%hu\n",cnt,sMin,sMax); break;
	    case 1 :
		while ((*fRead)(&lData,sizeof(lData),1,file)==1)
		    if (++cnt==1)
			lMin=lMax=lData;
		    else {
			if (lData<lMin) lMin=lData;
			if (lData>lMax) lMax=lData;
		    }

		printf("%d\t%lu\t%lu\n",cnt,lMin,lMax); break;
	    default :
		fprintf(stderr,"unknown data type : %d\n",type); break;
	}
	if (file!=stdin) fclose(file); return 0;
}
