
#include <stdio.h>
#include "ctd.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	CTD	*ctd;
	FILE	*file;
	int	a,u;
	double	tmp;

	if (argc!=3) {
	    fputs("usage : ctd2pua CTD binaryArray\n",stderr); exit(1);
	}

	if ((ctd=ReadCTD(argv[1]))==NULL) exit(1);

	fprintf(stderr,"%lf\t%lf\t%d\n",ctd->Ld/ctd->Lc,ctd->U/ctd->Nu,ctd->Mt);

	if (argv[2][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[2],"wb"))==NULL) {
		fputs("file not stored.\n",stderr); exit(1);
	    }

	fprintf(file,"%d\t%d\n",ctd->Nu,ctd->Ma);

	for (a=0; a<ctd->Ma; a++)
	for (u=0; u<ctd->Nu; u++) {
	    tmp=ctd->p[a][u]; fwrite(&tmp,sizeof(tmp),1,file);
	}
	if (file!=stdout) fclose(file); return 0;
}
