
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,x,y;
	Cell	**cell;
	double	base,step;

	if (argc!=4) {
	    fputs("usage : tiff2a TIFF base step\n",stderr); exit(1);
	}

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	base=atof(argv[2]);
	step=atof(argv[3]);

	printf("%d\t%d\n",Nx,Ny);

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) printf("%lf\n",base+step*(double)cell[y][x]);

	return 0;
}
