
#include <stdio.h>

static size_t	fReadRev(ptr,size,items,file)
char		*ptr;
size_t		size,items;
FILE		*file;
{
	size_t	i,j,size1=size-1,size2=size/2,read=fread(ptr,size,items,file);
	char	*p1,*p2,c;

	for (i=0; i<read; i++) {
	    for (j=0; j<size2; j++) {
		p1=ptr+j; p2=ptr+size1-j; c=(*p1); *p1=(*p2); *p2=c;
	    }
	    ptr+=size;
	}
	return read;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	unsigned short	tmp=0x1234;
	unsigned char	*ptr=(unsigned char *)&tmp;
	size_t		(*fRead)()=(*ptr==(tmp&0xff))?fread:fReadRev;
	FILE		*file;
	int		loc=1,cnt=0;
	float		min,max,data;
	short		width;

	if (argc!=2) {
	    fputs("usage : ctr2dmm CTR\n",stderr); exit(1);
	}

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) {
		fprintf(stderr,"%s : file not open.\n",argv[1]); exit(1);
	    }

	do (void)fgetc(file); while (++loc<380);
	if (fgetc(file)==1) {
	    (void)(*fRead)(&min,sizeof(min),1,file); loc+=sizeof(min);
	    (void)(*fRead)(&max,sizeof(max),1,file); loc+=sizeof(max);

	    printf("enable\t%f\t%f\n",min,max);
	}
	++loc;

	do (void)fgetc(file); while (++loc<393);
	if (fgetc(file)==1) {
	    (void)fgetc(file); ++loc;
	    (void)(*fRead)(&min,sizeof(min),1,file); loc+=sizeof(min);
	    (void)(*fRead)(&max,sizeof(max),1,file); loc+=sizeof(max);

	    printf("absolute\t%f\t%f\n",min,max);
	}
	++loc;

	do (void)fgetc(file); while (++loc<527);
	(void)(*fRead)(&width,sizeof(width),1,file); loc+=sizeof(width);

	printf("%d\t%d\n",(int)width,(int)width*(int)width);

	do (void)fgetc(file); while (++loc<=1024);
	while ((*fRead)(&data,sizeof(data),1,file)==1)
	    if (++cnt==1)
		min=max=data;
	    else {
		if (data<min) min=data;
		if (data>max) max=data;
	    }

	printf("%d\t%f\t%f\n",cnt,min,max);

	if (file!=stdin) fclose(file); return 0;
}
